import { CheckOptions, Resource } from '@/internal';
import { Template } from './template';
import { Project } from './project';
export interface RenderOptions {
    /**
     * always prompt the question,
     * even though it was answered.
     */
    ignoreAnswered?: boolean;
}
export declare class Compiler {
    readonly resource: Resource;
    private readonly eventEmitter;
    constructor(resource: Resource);
    get template(): Template;
    get project(): Project;
    emit(name: string): void;
    private prompt;
    render(options?: RenderOptions): Promise<void>;
    check(options: CheckOptions): Promise<void>;
    private generateMilirc;
}
