import { Resource } from '@/internal';
import { Encoding } from '@/consts';
export interface CheckOptions {
    showDiff?: boolean;
    fold?: boolean;
}
export declare class CompiledFile {
    templatePath: string;
    encoding: Encoding;
    projectPath: string;
    private projectContent?;
    projectFileExisted: boolean;
    content: string;
    resource: Resource;
    /** Delete project file */
    deleted: boolean;
    /** Need to render file */
    renderable: boolean;
    /** Additional file information that added by handler */
    addition: {};
    constructor(templatePath: string, content: string, encoding: Encoding, projectPath: string, resource: Resource, projectFileExisted: boolean);
    getProjectContent(): Promise<string>;
    render(): Promise<void>;
    check(options?: CheckOptions): Promise<boolean>;
}
export declare type CompiledFiles = CompiledFile[];
