declare type QuesstionTypes = 'input' | 'confirm' | 'number' | 'list' | 'rawlist' | 'expand' | 'checkbox' | 'password' | 'editor';
declare type Validator = (input: string) => boolean | string;
declare type Choice = string | number | boolean | DetailedChoice;
declare type Choices = ((answers: Answers) => Choice[]) | Choice[];
declare type Filter = <T>(value: T) => T;
declare type When = (answers: Answers) => boolean;
interface DetailedChoice {
    name: string;
    value: string | number | boolean;
    checked?: boolean;
    disabled?: boolean;
}
export interface QuestionOptions {
    type?: QuesstionTypes;
    name: string;
    message?: string | Function;
    default?: any;
    choices?: Choices;
    validate?: Validator;
    filter?: Filter;
    transformer?: Function;
    when?: When;
    pageSize?: number;
    prefix?: string;
    suffix?: string;
}
export declare class Question {
    type: QuesstionTypes;
    name: string;
    message: string | Function;
    default: any;
    choices: Choices;
    validate: Validator;
    filter: Filter;
    transformer: Function;
    when: When;
    pageSize: number;
    prefix: string;
    suffix: string;
    constructor(options: QuestionOptions);
    private includesByChoices;
    answered(answers: Answers): boolean;
}
export declare type Questions = Question[];
export interface Answers {
    [name: string]: string | number | boolean | (string | number)[];
}
export declare type Prompter = (question: Question[]) => Promise<Answers>;
export {};
