import { Compiler } from '@/internal';
import { Project } from './project';
import { Template } from './template';
import { Maybe } from '@/types.js';
import { Answers } from './question.js';
export interface Milirc {
    mili: {
        version: string;
    };
    template: {
        repository: string;
        version?: string;
    };
    answers?: Answers;
}
export declare type MiliOperations = 'init' | 'upgrade' | 'update' | 'check';
export declare class Resource {
    readonly mili: {
        version: string;
    };
    readonly project: Project;
    readonly template: Template;
    readonly operation: MiliOperations;
    constructor(operation: MiliOperations, project: Project, template: Template);
    get answers(): Maybe<Answers>;
    get milirc(): Milirc;
    compile(): Promise<Compiler>;
}
