var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import semver from 'semver';
import { Compiler } from "../internal";
import { version } from "../../package.json";
import { logger } from "../utils";
export class Resource {
    constructor(operation, project, template) {
        this.mili = { version };
        if (!template.engines) {
            logger.warn('The template.engines is not set, you need to check the mili version manually.');
        }
        else if (!semver.satisfies(this.mili.version, template.engines)) {
            throw new Error([
                `The mili version template need is ${template.engines}`,
                `But mili version used is ${this.mili.version}`,
            ].join('\n'));
        }
        this.operation = operation;
        this.project = project;
        this.template = template;
    }
    get answers() {
        return this.project.answers;
    }
    get milirc() {
        const { mili, project, template, answers } = this;
        let { record } = template.repository;
        if (typeof record === 'function')
            record = record(project.path);
        return {
            mili,
            template: {
                repository: record,
                version: template.repository.version,
            },
            answers,
        };
    }
    compile() {
        return __awaiter(this, void 0, void 0, function* () {
            return new Compiler(this);
        });
    }
}
