var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { logger } from "../utils";
import { Project, Effect, EffectOptions } from "../internal";
export default (options = {}) => __awaiter(void 0, void 0, void 0, function* () {
    const cwd = options.cwd || process.cwd();
    Effect.replace(options.effect);
    const project = yield Project.load(cwd);
    const repo = yield project.getTemplateRepo();
    if (!(yield repo.isVerioning())) {
        throw new Error('`mili outdated` cannot check the template without version control');
    }
    else if (yield repo.isLatest()) {
        logger.info('Congratulations, the current template is the latest version.');
    }
    else {
        logger.warn([
            '',
            '',
            'Project Mili Template Is Outdated',
            'run `npx mili upgrade` to upgrade template',
            '',
            '',
        ].join('\n'));
    }
});
