var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { FileGenerator, Handler } from "../class";
export default function (name, begin, end = begin) {
    const genFile = (file) => __awaiter(this, void 0, void 0, function* () {
        if (!file.projectFileExisted)
            return;
        const projectContent = yield file.getProjectContent();
        let beginIndex = projectContent.indexOf(begin);
        if (beginIndex === -1)
            return;
        beginIndex += begin.length;
        const endIndex = projectContent.indexOf(end, beginIndex);
        if (endIndex === -1)
            return;
        file.addition[name] = projectContent.substring(beginIndex, endIndex);
    });
    return new Handler(genFile);
}
