var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import mustache from 'mustache';
import { Handler, FileGenerator, PathGenerator } from "../internal";
const genFile = (file, resource) => __awaiter(void 0, void 0, void 0, function* () {
    const view = {
        mili: resource.mili,
        project: resource.project,
        template: resource.template,
        answers: resource.answers,
        addition: file.addition,
    };
    file.content = mustache.render(file.content, view);
});
const genPath = (path) => __awaiter(void 0, void 0, void 0, function* () { return path.replace(/.mustache$/, ''); });
export default new Handler(genFile, genPath);
