var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import git from 'simple-git/promise';
import dirExist from "./dir-exist";
export default (path) => __awaiter(void 0, void 0, void 0, function* () {
    if (!(yield dirExist(path)))
        return false;
    if (!(yield git(path).checkIsRepo()))
        return false;
    const toplevel = yield git(path).revparse(['--show-toplevel']);
    if (toplevel.replace(/\n$/, '') !== path)
        return false;
    return true;
});
