import { CompiledFile, Resource } from '@/internal';
export interface FileGenerator {
    (file: CompiledFile, resource: Readonly<Resource>): Promise<void>;
}
export interface PathGenerator {
    (path: string, resource: Readonly<Resource>): Promise<string>;
}
interface HandlerDuck {
    genFile: FileGenerator;
    genPath: PathGenerator;
}
export declare class Handler {
    genFile: FileGenerator;
    genPath: PathGenerator;
    constructor(genFile: FileGenerator, genPath?: PathGenerator);
    static compose(handlers: Handler[]): Handler;
    static find(name: string): Handler | null;
    static format(handler: string | HandlerDuck | ((buildIn: any) => Handler)): Handler;
}
export declare type Handlers = Handler[];
export {};
