"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const internal_1 = require("../internal");
const recursive_execte_1 = __importDefault(require("../utils/recursive-execte"));
exports.default = recursive_execte_1.default((options = {}) => __awaiter(void 0, void 0, void 0, function* () {
    const { showDiff = false, fold = false, cwd = process.cwd(), noDeps = false, } = options;
    internal_1.Effect.replace(options.effect);
    const project = yield internal_1.Project.load(cwd);
    const repo = yield project.getTemplateRepo();
    const template = yield repo.install({ noDeps });
    const resource = new internal_1.Resource('check', project, template);
    const compiler = yield resource.compile();
    yield compiler.check({ showDiff, fold });
    yield compiler.emit('checked');
}));
