"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const internal_1 = require("../internal");
const utils_1 = require("../utils");
exports.default = (options) => __awaiter(void 0, void 0, void 0, function* () {
    const cwd = options.cwd || process.cwd();
    const name = options.name;
    const noDeps = options.noDeps || false;
    const version = options.version || 'latest';
    const force = options.force || false;
    if (!options.repository)
        throw new TypeError('options.repository is required for `mili.init(options)`');
    internal_1.Effect.replace(options.effect);
    if (force)
        yield utils_1.checkWorkDir(cwd);
    const repo = yield internal_1.Repository.format(options.repository);
    if (version)
        yield repo.checkout(version);
    const template = yield repo.install({ noDeps });
    const project = yield internal_1.Project.load(cwd);
    if (options.name)
        project.name = name;
    const resource = new internal_1.Resource('init', project, template);
    const compiler = yield resource.compile();
    yield compiler.render({ ignoreAnswered: true });
    yield compiler.emit('initialized');
});
