"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const js_yaml_1 = __importDefault(require("js-yaml"));
const merge_deep_1 = __importDefault(require("merge-deep"));
const mergeYaml = (file) => __awaiter(void 0, void 0, void 0, function* () {
    let content = file.content;
    const beginMatched = content.match(/^\s*/g);
    const beginBlank = beginMatched ? beginMatched[0] : '';
    const endMatched = content.match(/\s*$/g);
    const endBlank = endMatched ? endMatched[0] : '';
    let result = content;
    if (!file.projectFileExisted) {
        try {
            content = js_yaml_1.default.load(file.content);
            result = js_yaml_1.default.dump(content).replace(/\s*$/, '');
        }
        catch (e) {
            throw new Error([
                'The template file and the project file failed to merge due to a json syntax error in the template file.',
                'The project file will be overwritten directly by the template file.',
                `path: ${file.templatePath}`,
            ].join('\n'));
        }
    }
    else {
        let projectContent = yield file.getProjectContent();
        try {
            content = js_yaml_1.default.load(file.content);
        }
        catch (e) {
            throw new Error([
                'The template file and the project file failed to merge due to a json syntax error in the template file.',
                'The project file will be overwritten directly by the template file.',
                `path: ${file.templatePath}`,
            ].join('\n'));
        }
        try {
            projectContent = js_yaml_1.default.load(projectContent);
        }
        catch (e) {
            throw new Error([
                'The template file and the project file failed to merge due to a yaml syntax error in the project file.',
                'The project file will be overwritten directly by the template file.',
                `path: ${file.projectPath}`,
            ].join('\n'));
        }
        result = js_yaml_1.default.dump(merge_deep_1.default(projectContent, content))
            .replace(/\s*$/, '');
    }
    file.content = `${beginBlank}${result}${endBlank}`;
});
exports.default = mergeYaml;
