"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const consts_1 = require("../consts");
const infer_encoding_normally_1 = __importDefault(require("./infer-encoding-normally"));
function default_1(mapping) {
    const encodingRegExpMap = Object.entries(mapping)
        .map(([key, value]) => {
        if (typeof value === 'string') {
            const pattern = new RegExp(value);
            return { encoding: key, match: v => pattern.test(v) };
        }
        else if (typeof value === 'function') {
            return { encoding: key, match: v => value(v) };
        }
        throw new Error('Encoding mapping should be function or regexp');
    });
    return path => {
        const item = encodingRegExpMap.find(item => item.match(path));
        if (item && Object.values(consts_1.Encoding).includes(item.encoding))
            return item.encoding;
        else
            return infer_encoding_normally_1.default(path);
    };
}
exports.default = default_1;
