"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const promise_1 = __importDefault(require("simple-git/promise"));
const dir_exist_1 = __importDefault(require("./dir-exist"));
exports.default = (path) => __awaiter(void 0, void 0, void 0, function* () {
    if (!(yield dir_exist_1.default(path)))
        return false;
    if (!(yield promise_1.default(path).checkIsRepo()))
        return false;
    const toplevel = yield promise_1.default(path).revparse(['--show-toplevel']);
    if (toplevel.replace(/\n$/, '') !== path)
        return false;
    return true;
});
